<?php

/*
 * Copyright (C) 2007
 * Licensed to CiviCRM under the Academic Free License version 3.0.
 *
 * Written and contributed by Webentwicklung Lars Schröter (der-lars-online.de)
 *
 */

/**
 * @package CRM
 * @author Lars Schröter
 * $Id:$
 **/

require_once 'CRM/Core/Payment/DrupalDirectDebit.php';

class CRM_Contribute_Payment_DrupalDirectDebit extends CRM_Core_Payment_DrupalDirectDebit {
    /** 
     * We only need one instance of this object. So we use the singleton 
     * pattern and cache the instance in this variable 
     *
     * @var object 
     * @static 
     */
    static private $_singleton = null;
    
    /**
     * Constructor
     *
     * @param string $mode the mode of operation: live or test
     *
     * @return void
     */
    function __construct( $mode, &$paymentProcessor ) {
        parent::__construct( $mode, $paymentProcessor );
    }

    /**
     * singleton function used to manage this object
     *
     * @param string $mode the mode of operation: live or test
     *
     * @return object
     * @static
     */
    static function &singleton( $mode, &$paymentProcessor ) {
        if (self::$_singleton === null ) {
            self::$_singleton =& new CRM_Contribute_Payment_DrupalDirectDebit( $mode, $paymentProcessor );
        }
        return self::$_singleton;
    }

}


